<template>
  <form class="edit-project" @submit.prevent="submit">
    <div class="form-field">
      <label for="name">Название</label>
      <prime-input-text
        id="name"
        v-model="name"
        type="text"
        :disabled="isLoading"
        autofocus
      />
    </div>

    <div class="form-field">
      <label for="domain">Домен</label>
      <prime-input-text
        id="domain"
        v-model="domain"
        type="text"
        :disabled="isLoading"
      />
    </div>

    <div class="form-field">
      <label for="periodicity">Периодичность</label>
      <prime-dropdown
        id="periodicity"
        v-model="periodicity"
        :options="periodicityValues"
        :disabled="isLoading"
      />
    </div>

    <prime-button label="Сохранить" type="submit" />
  </form>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeDropdown from 'primevue/dropdown/Dropdown.vue';
import PrimeInputText from 'primevue/inputtext/InputText.vue';
import { defineComponent, PropType } from 'vue';
import { updateProject, createProject } from '@/api/handler/projects';
import { Project } from '@/models/projects';

type Data = Omit<Project, 'id'> & {
  isLoading: boolean;
}

export default defineComponent({
  name: 'edit-project',
  components: {
    PrimeButton,
    PrimeDropdown,
    PrimeInputText,
  },
  props: {
    project: { type: Object as PropType<Project | null>, default: () => null },
  },
  emits: ['close', 'update', 'create'],
  data(): Data {
    return {
      name: '',
      domain: '',
      periodicity: 1,

      isLoading: false,
    };
  },
  computed: {
    periodicityValues(): (1 | 7 | 30)[] {
      return [1, 7, 30];
    },
  },
  created() {
    if (!this.project) {
      return;
    }

    const { name, domain, periodicity } = this.project;
    this.name = name;
    this.domain = domain;
    this.periodicity = periodicity;
  },
  methods: {
    async submit() {
      this.isLoading = true;
      if (this.project !== null) {
        const { id } = this.project;
        const { name, domain, periodicity } = this;
        const res = await updateProject({
          id,
          args: {
            name,
            domain,
            periodicity,
          },
        });

        if (res.__state === 'success') {
          this.$emit('update', res.data);
          this.$emit('close');
        } else {
          this.$toast.add({ severity: 'error', detail: 'Что-то пошло не так', life: 3000 });
        }
      } else {
        const { name, domain, periodicity } = this;
        const res = await createProject({
          name,
          domain,
          periodicity,
        });

        if (res.__state === 'success') {
          this.$emit('create', res.data);
          this.$emit('close');
        } else {
          this.$toast.add({ severity: 'error', detail: 'Что-то пошло не так', life: 3000 });
        }
      }
      this.isLoading = false;
    },
  },
});
</script>

<style lang="scss" scoped>
.edit-project {
  width: 25rem;
}

.p-field * {
  display: block;
}
</style>
